#include <stdint.h>
#include <stdio.h>
#include <bbb_dmtimer.h>

int main(void){
    // initialize DMTIMER lib
    if(bbb_dmtimer_init()){
        fprintf(stderr, "Can not initialize bbb_dmtimer lib\n");
        return(1);
    }

    // Timer6 enable
    CM_PER[CM_PER_TIMER6_CLKCTRL] = MODULE_ENABLED;         // Set 0x44E000F0 to 0x02
    // Set TCRR clock source
    CM_DPLL[CLKSEL_TIMER6_CLK] = CLK_M_OSC;                 // Set 0x44E0051C to 0x1
    // Set TLDR value
    DMTIMER[6][TLDR] = 0;                                   // Set 0x48048040 to 0x0
    // Omit TCRR initialization because any value is OK.
    // Set interrupt
    DMTIMER[6][IRQENABLE_SET] |= TCAR_EN_FLAG;              // Set 0x48048040 to 0x4
    // Clear interrupt flag
    DMTIMER[6][IRQSTATUS] |= TCAR_EN_FLAG;                  // Set 0x48048040 to 0x4

    // Set free run cuonter
    // GPO_CFG[14]   = 1(Input)
    // CAPT_MODE[13] = 1(Capture on second event)
    // PT[12]        = X(Don't care)
    // TRG[11-10]    = 00(No trigger)
    // TCM[9-8]      = 01(Capture on low to high transition)
    // SCPWM[7]      = X(Don't care)
    // CE[6]         = 0(Compare mode is disabled)
    // PRE[5]        = 0(Prescaler disable)
    // PTV[4-2]      = X(Don't care)
    // AR[1]         = 1(Auto-reload timer)
    // ST[0]         = 1(Start timer)
    DMTIMER[6][TCLR] = 0x6103;                              // Set 0x48048038 to 0x6103

    while(1){
        if(DMTIMER[6][IRQSTATUS]){
            uint32_t cycle = DMTIMER[6][TCAR2] - DMTIMER[6][TCAR1];
            printf("%.2f Hz\n", (float)24000000/cycle);
            // Clear interrupt flag
            DMTIMER[6][IRQSTATUS] |= TCAR_EN_FLAG;
        }
    }

    // not reach
    bbb_dmtimer_free();
    return(0);
}
