#include <stdint.h>
#include <stdio.h>
#include <bbb_dmtimer.h>


int main(void){
    // initialize DMTIMER lib
    if(bbb_dmtimer_init()){
        fprintf(stderr, "Can not initialize bbb_dmtimer lib\n");
        return(1);
    }

    /*
     * DMTIMER5 configuration
     * 1KHz, 25% duty cycle
     */

    // Timer5 enable
    CM_PER[CM_PER_TIMER5_CLKCTRL] = MODULE_ENABLED;         // Set 0x44E000EC to 0x02

    // Set TCRR clock source
    CM_DPLL[CLKSEL_TIMER5_CLK] = CLK_M_OSC;                 // Set 0x44E00518 to 0x1

    // Set TLDR value(wave length)
    DMTIMER[5][TLDR] = (uint32_t)(-24000);                  // Set 0x48046040 to 0xFFFFFFA240

    // Set initial TCRR value
    DMTIMER[5][TCRR] = DMTIMER[5][TLDR];                    // Set 0x4804603C to 0xFAAAAAAB

    // Set match value of falling edge
    DMTIMER[5][TMAR] = (uint32_t)(-18000);                  // Set 0x4804604C to 0xFFFFFF6960

    // Set PWM
    // GPO_CFG[14]   = 0(Output)
    // CAPT_MODE[13] = X(Don't care)
    // PT[12]        = 1(Toggle)
    // TRG[11-10]    = 2(Trigger on overflow and match)
    // TCM[9-8]      = X(Don't care)
    // SCPWM[7]      = 0
    // CE[6]         = 1(Compare mode is enableed)
    // PRE[5]        = 0(Prescaler disable)
    // PTV[4-2]      = X(Don't care)
    // AR[1]         = 1(Auto-reload timer)
    // ST[0]         = 1(Start timer)
    DMTIMER[5][TCLR] = 0x1843;                                // Set 0x48046038 to 0x18C3

    bbb_dmtimer_free();
    return(0);
}
