#include <stdint.h>
#include <stdio.h>
#include <bbb_dmtimer.h>

int main(void){
    // initialize DMTIMER lib
    if(bbb_dmtimer_init()){
        fprintf(stderr, "Can not initialize bbb_dmtimer lib\n");
        return(1);
    }

    /*
     * DMTIMER6 configuration
     * 1MHz, 50% duty cycle
     */

    // Timer6 enable
    CM_PER[CM_PER_TIMER6_CLKCTRL] = MODULE_ENABLED;         // Set 0x44E000F0 to 0x02
    // Set TCRR clock source
    CM_DPLL[CLKSEL_TIMER6_CLK] = CLK_M_OSC;                 // Set 0x44E0051C to 0x1
    // Set TLDR value(1/2 wave length)
    DMTIMER[6][TLDR] = (uint32_t)(-12);                     // Set 0x48048040 to 0xFFFFFFF4
    // Set initial TCRR value
    DMTIMER[6][TCRR] = DMTIMER[6][TLDR];                    // Set 0x4804803C to 0xFFFFFFF4

    // Set free run cuonter
    // GPO_CFG[14]   = 0(Output)
    // CAPT_MODE[13] = X(Don't care)
    // PT[12]        = 1(Toggle)
    // TRG[11-10]    = 1(Trigger on overflow)
    // TCM[9-8]      = X(Don't care)
    // SCPWM[7]      = X(Don't care)
    // CE[6]         = 0(Compare mode is disabled)
    // PRE[5]        = 0(Prescaler disable)
    // PTV[4-2]      = X(Don't care)
    // AR[1]         = 1(Auto-reload timer)
    // ST[0]         = 1(Start timer)
    DMTIMER[6][TCLR] = 0x1403;                              // Set 0x48048038 to 0x1403

    bbb_dmtimer_free();
    return(0);
}
